<?php

namespace Domain\Normalizer;

use Domain\Model\MemoryConfiguration;

class MemoryConfigurationNormalizer implements Normalizer
{
    /**
     * @return string[]
     */
    public function getHeaders(): array
    {
        return [
            'vendor',
            'module',
            'type',
            'speed',
            'supported_speed',
            'number_of_modules',
            'module_size',
            'total_size',
            'chip',
            'dual_sided',
            'dimm_socket_support',
            'overclocking_support',
            'overclocking_verified',
            'dc_overclocking_verified',
            'note',
        ];
    }

    public function normalize(object $object): array
    {
        /** @var MemoryConfiguration $object */
        return [
            'vendor'                   => $object->vendor,
            'module'                   => $object->module,
            'type'                     => $object->type,
            'speed'                    => $object->speed,
            'supported_speed'          => $object->supportedSpeed,
            'number_of_modules'        => $object->numberOfModules,
            'module_size'              => $object->moduleSizeHr,
            'total_size'               => $object->totalSizeHr,
            'chip'                     => $object->chip,
            'dual_sided'               => $object->isDualSided,
            'dimm_socket_support'      => $object->dimmSocketSupport,
            'overclocking_support'     => $object->overclockingSupport,
            'overclocking_verified'    => $object->overclockingVerified,
            'dc_overclocking_verified' => $object->dualChannelOverclockingVerified,
            'note'                     => $object->note,
        ];
    }
}
